Index: /palm/trunk/SOURCE/user_data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/user_data_output_3d.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_data_output_3d.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -31,5 +31,5 @@
     LOGICAL ::  found
 
-    REAL(spk), DIMENSION(nxl-1:nxr+1,nys-1:nyn+1,nzb:nz_do) ::  local_pf
+   REAL(spk), DIMENSION(nxlg:nxrg,nysg:nyng,nzb:nz_do) ::  local_pf
 
 
@@ -45,6 +45,6 @@
 !       CASE ( 'u2' )
 !          IF ( av == 0 )  THEN
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
 !                   DO  k = nzb, nz_do
 !                      local_pf(i,j,k) = u2(k,j,i)
@@ -53,6 +53,6 @@
 !             ENDDO
 !          ELSE
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
 !                   DO  k = nzb, nz_do
 !                      local_pf(i,j,k) = u2_av(k,j,i)
Index: /palm/trunk/SOURCE/user_init.f90
===================================================================
--- /palm/trunk/SOURCE/user_init.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_init.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -30,6 +30,6 @@
 !-- Here the user-defined initializing actions follow:
 !-- Sample for user-defined output
-!    ALLOCATE( u2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
-!    ALLOCATE( ustvst(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) );  ustvst = 0.0
+!    ALLOCATE( u2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!    ALLOCATE( ustvst(nzb:nzt+1,nysg:nyng,nxlg:nxrg) );  ustvst = 0.0
 
 !-- Sample for user-defined time series
Index: /palm/trunk/SOURCE/user_init_plant_canopy.f90
===================================================================
--- /palm/trunk/SOURCE/user_init_plant_canopy.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_init_plant_canopy.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -49,7 +49,7 @@
 !--       plant canopy extends only over the second half of the 
 !--       model domain along x
-!          DO  i = nxl-1, nxr+1
+!          DO  i = nxlg, nxrg
 !             IF ( i >= INT(nx+1/2) ) THEN
-!                DO  j = nys-1, nyn+1
+!                DO  j = nysg, nyng
 !                   lad_s(:,j,i) = lad(:)
 !                   cdc(:,j,i)   = drag_coefficient
Index: /palm/trunk/SOURCE/user_read_restart_data.f90
===================================================================
--- /palm/trunk/SOURCE/user_read_restart_data.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_read_restart_data.f90	(revision 667)
@@ -7,5 +7,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Allocation with nbgp.
 !
 ! Former revisions:
@@ -50,9 +50,8 @@
                                                        offset_ya
 
-    REAL, DIMENSION(nys_on_file-1:nyn_on_file+1,nxl_on_file-1:nxr_on_file+1) ::&
+    REAL, DIMENSION(nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: &
           tmp_2d
 
-    REAL, DIMENSION(nzb:nzt+1,nys_on_file-1:nyn_on_file+1, &
-                    nxl_on_file-1:nxr_on_file+1) ::        &
+    REAL, DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: &
           tmp_3d
 
Index: /palm/trunk/SOURCE/wall_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/wall_fluxes.f90	(revision 666)
+++ /palm/trunk/SOURCE/wall_fluxes.f90	(revision 667)
@@ -62,10 +62,10 @@
        INTEGER ::  i, j, k, wall_index
 
-       INTEGER, DIMENSION(nys-1:nyn+1,nxl-1:nxr+1) ::  nzb_uvw_inner, &
+       INTEGER, DIMENSION(nysg:nyng,nxlg:nxrg) ::  nzb_uvw_inner, &
                                                        nzb_uvw_outer
        REAL ::  a, b, c1, c2, h1, h2, zp
        REAL ::  pts, pt_i, rifs, u_i, v_i, us_wall, vel_total, ws, wspts
 
-       REAL, DIMENSION(nys-1:nyn+1,nxl-1:nxr+1)   ::  wall
+       REAL, DIMENSION(nysg:nyng,nxlg:nxrg)   ::  wall
        REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wall_flux
 
@@ -348,5 +348,5 @@
        REAL ::  rifs
 
-       REAL, DIMENSION(nys-1:nyn+1,nxl-1:nxr+1)   ::  wall
+       REAL, DIMENSION(nysg:nyng,nxlg:nxrg)   ::  wall
        REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wall_flux
 
Index: /palm/trunk/SOURCE/write_compressed.f90
===================================================================
--- /palm/trunk/SOURCE/write_compressed.f90	(revision 666)
+++ /palm/trunk/SOURCE/write_compressed.f90	(revision 667)
@@ -1,9 +1,9 @@
  SUBROUTINE write_compressed( field, fid_avs, fid_fld, my_id, nxl, nxr, nyn, &
-                              nys, nzb, nz_do3d, prec )
+                              nys, nzb, nz_do3d, prec, nbgp )
 
 !------------------------------------------------------------------------------!
 ! Current revisions:
 ! -----------------
-! 
+! Array bounds and nx, ny adapted with nbgp.
 !
 ! Former revisions:
@@ -58,7 +58,7 @@
 
     INTEGER, INTENT(IN) ::  fid_avs, fid_fld, my_id, nxl, nxr, nyn, nys, nzb, &
-                            nz_do3d, prec
-
-    REAL(spk), INTENT(IN) :: field(1:((nxr-nxl+3)*(nyn-nys+3)*(nz_do3d-nzb+1)))
+                            nz_do3d, prec, nbgp
+
+    REAL(spk), INTENT(IN) :: field(1:((nxr-nxl+1+2*nbgp)*(nyn-nys+1+2*nbgp)*(nz_do3d-nzb+1)))
 
 !
@@ -73,6 +73,6 @@
     ENDDO
 
-    nx     = nxr - nxl + 2
-    ny     = nyn - nys + 2
+    nx     = nxr - nxl + 2*nbgp
+    ny     = nyn - nys + 2*nbgp
     nz     = nz_do3d - nzb
     length = (nx+1) * (ny+1) * (nz+1)
